bind(X,X).

memberLX(_, [], false).
memberLX(X, [X|_], true).
memberLX(X, [Z|Q], Y) :- Z \== Y, memberL(X,Q, Y).

memberL(A, B, true) :- memL(A, B).
memberL(A, B, false) :- \+ memL(A, B).

memL(H, [H|_]).
memL(H, [_|T]) :- memL(H,T).

deleteL([], _, []).
deleteL([X|Q], X, Q).
deleteL([T|Q], X, [T|Q2]) :- deleteL(Q,X,Q2).

mode ap(+,+,-).
appendL([], X, X).
appendL([X|Q1], X, [X|Q1]).
appendL([T|Q1], X, [T|Q2]) :- appendL(Q1,X,Q2).

notdeleted(F,ad(_,ADel)) :- memberL(F,ADel,false).

deleted(F,ad(_,ADel)) :- memberL(F,ADel,true).

inserted(F,ad(AIns,_)) :- memberL(F,AIns,true).

delete_ad(F,ad(AIns, ADel),ad(AIns2,ADel2)) :-
  appendL(ADel, [F], ADel2),
  deleteL(AIns, [F], AIns2).

insert_ad(F,ad(AIns,D),ad(AIns2,D)) :-
  appendL(AIns, [F], AIns2).

delete_sd(F,SIn,SOut) :-
  appendL(SIn, [F], SOut).

:- import incr_assert/1 from increval.

assert_ad([]).
assert_ad([H|T]) :- \+ H, incr_assert(H), assert_ad(T).
assert_ad([_|T]) :- assert_ad(T).
retract_ad([]).
retract_ad([H|T]) :- H, retract(H), retract_ad(T).
retract_ad([_|T]) :- retract_ad(T).
retract_sd([]).
retract_sd([H|T]) :- H, retract(H), retract_sd(T).
retract_sd([_|T]) :- retract_sd(T).

update_ad(ad(AIns,ADel)) :- retract_ad(ADel), assert_ad(AIns).

update_sd(Del) :- retract_sd(Del).

demo :- cputime(T1), testit, cputime(T2), T is T2 - T1,
        write('Time used: '),  write(T), write(' sec'), nl.
